//   
//  2 (18  2004 )

// Gauss
// version 1.0
// (c) Demidov Vladimir, 2004

//     
//   a[0][0]*x[0] + ... +   a[0][j]*x[j] + ... +   a[0][n-1]*x[n-1] = b[0]
//								...
//   a[i][0]*x[0] + ... +   a[i][j]*x[j] + ... +   a[i][n-1]*x[n-1] = b[i]
//								...
// a[n-1][0]*x[0] + ... + a[n-1][j]*x[j] + ... + a[n-1][n-1]*x[n-1] = b[n-1]

// www.demidovvova.narod.ru
// E-mail: demidovvova@narod.ru

// Microsoft Visual C++ 6.0
// Microsoft Visual C++ 7.0

#include <iostream> //      -
#include <math.h>  
#include <conio.h> //   Linux

using namespace std; //    Turbo C
const int n = 3;
const double EPS = 1e-10;

void Input_Vector (double X[n])
{
	int i;
	for (i=0; i<n; i++)
	{
		cout << "[" << i << "] = "; cin >> X[i];
	}
}

void Output_Vector (double X[n])
{
	int i;
	for (i=0; i<n-1; i++)
	{
		cout << X[i] << ", ";
	}
	if (n>0) cout << X[n-1] << endl;
}

void Input_Matrix (double X[n][n])
{
	int i, j;
	for (i=0; i<n; i++)
	{
		for (j=0; j<n; j++)
		{
			cout << "[" << i << ", " << j << "] = "; cin >> X[i][j];
		}
	}
}

void Output_Matrix (double X[n][n])
{
	int i, j;
	for (i=0; i<n; i++)
	{
		for (j=0; j<n-1; j++)
		{
			cout << X[i][j] << "\t";
		}
		//   if (n>0), .. n > i >= 0  =>  n > 0
		cout << X[i][n-1] << "\n";
	}
}

void Output_Matrix_Vector (double A[n][n], double B[n])
{
	int i, j;
	for (i=0; i<n; i++)
	{
		for (j=0; j<n; j++)
		{
			cout << A[i][j] << "\t";
		}
		//   if (n>0), .. n > i >= 0  =>  n > 0
		cout << "| " << B[i] << "\n";
	}
}

int Gauss (double A[n][n], double B[n], double X[n])
{
	int i, j, k;
	//  
	cout << "Output A | B:\n";
	Output_Matrix_Vector (A, B);
	for (k=0; k<n-1; k++)
	{
		for (i=k+1; i<n; i++)
		{
			for (j=k+1; j<n; j++)
			{
				A[i][j] = A[i][j]*A[k][k]- A[k][j]*A[i][k];
			}
			B[i]=B[i]*A[k][k]- B[k]*A[i][k];
			A[i][k] = 0;
		}
	}
	cout << "Output A | B:\n";
	Output_Matrix_Vector (A, B);
	//  
	for (i=n-1; i>=0; i--)
	{
		if (fabs(A[i][i]) < EPS) return i+1; // i+1 > 0 - 
		X[i] = B[i];
		for (j=i+1; j<n; j++)
		{
			X[i] -= A[i][j]*X[j]; // a -= b; <=> a = a - b;
		}
		X[i] /= A[i][i];
	}
	return 0; //  
}

int main (void)
{
	cout << "Gauss\nversion 1.0\n"
		<<  "  a[0][0]*x[0] + ... +   a[0][j]*x[j] + ... +   a[0][n-1]*x[n-1] = b[0]\n"
		<<  "\t\t\t. . .\n"
		<<  "  a[i][0]*x[0] + ... +   a[i][j]*x[j] + ... +   a[i][n-1]*x[n-1] = b[i]\n"
		<<  "\t\t\t. . .\n"
		<<  "a[n-1][0]*x[0] + ... + a[n-1][j]*x[j] + ... + a[n-1][n-1]*x[n-1] = b[n-1]\n";
	cout << "Rang (n) = " << n << endl;
	cout << "A * X = B\n";
	cout << "Input matrix A:\n";
	double A[n][n];
	Input_Matrix (A);
	cout << "Output matrix A:\n";
	Output_Matrix (A);
	cout << "Input vector B:\n";
	double B[n];
	Input_Vector (B);

	double X[n];
	int er = Gauss (A, B, X);
	if (er > 0) cout << "Error in " << er << " string!\n";
	else 
	{
		cout << "Vector X:\n";
		Output_Vector (X);
	}
	getch (); // .   Linux.  #include <conio.h> 
	return 0;
}